--- openssl-0.9.8a-org/util/pl/OS2-EMX.pl	2003-11-28 23:51:28.000000000 +0900
+++ openssl-0.9.8a/util/pl/OS2-EMX.pl	2005-11-13 06:30:28.000000000 +0900
@@ -3,8 +3,11 @@
 # OS2-EMX.pl - for EMX GCC on OS/2
 #
 
+#$ssl=	"open_ssl";
+#$crypto="cryptssl";
+
 $o='/';
-$cp='cp';
+$cp='cp -p';
 $rm='rm -f';
 
 $preamble = "SHELL=sh\n";
@@ -25,7 +28,7 @@
 
 # EXE linking stuff
 $link='${CC}';
-$lflags='${CFLAGS} -Zbsd-signals -s';
+$lflags='${CFLAGS} -Zbsd-signals -s -Zstack 0x2000';
 $efile='-o ';
 $exep='.exe';
 $ex_libs="-lsocket";
@@ -68,6 +71,7 @@
 	$sha1_asm_src="crypto/sha/asm/s1-os2.asm";
 	$rmd160_asm_obj="crypto/ripemd/asm/rm-os2$obj";
 	$rmd160_asm_src="crypto/ripemd/asm/rm-os2.asm";
+	$cflags.="-DBN_ASM -DMD5_ASM -DSHA1_ASM -DRMD160_ASM -DOPENSSL_BN_ASM_PART_WORDS ";
 	}
 
 if ($shlib)
@@ -87,18 +91,21 @@
 	$target="$target";
 	($Name=$name) =~ tr/a-z/A-Z/;
 
-	$ret.="$target: \$(${Name}OBJ)\n";
+#	$ret.="$target: \$(${Name}OBJ)\n";
+	$ret.="$target: $obj\n";
 	if (!$shlib) 
 		{
 		$ret.="\t\$(RM) $target\n";
-		$ret.="\t\$(MKLIB) $target \$(${Name}OBJ)\n";
+#		$ret.="\t\$(MKLIB) $target \$(${Name}OBJ)\n";
+		$ret.="\t\$(MKLIB) $target $obj\n";
 		$ret.="\t\$(RANLIB) $target\n\n";
 		}
 	else
 		{
 		local($ex)=($target =~ /O_SSL/)?' $(L_CRYPTO)':'';
 		$ex.=' -lsocket';
-		$ret.="\t\$(LINK) \$(SHLIB_CFLAGS) \$(MLFLAGS) $efile$target \$(SHLIB_EX_OBJ) \$(${Name}OBJ) $ex os2/${Name}.def\n";
+#		$ret.="\t\$(LINK) \$(SHLIB_CFLAGS) \$(MLFLAGS) $efile$target \$(SHLIB_EX_OBJ) \$(${Name}OBJ) $ex os2/${Name}.def\n";
+		$ret.="\t\$(LINK) \$(SHLIB_CFLAGS) \$(MLFLAGS) $efile$target \$(SHLIB_EX_OBJ) $obj $ex os2/${Name}.def\n";
 		$ret.="\temximp -o $out_def/$name.a os2/${Name}.def\n";
 		$ret.="\temximp -o $out_def/$name.lib os2/${Name}.def\n\n";
 		}
--- openssl-0.9.8a-org/os2/OS2-EMX.cmd	2003-11-28 23:51:30.000000000 +0900
+++ openssl-0.9.8a/os2/OS2-EMX.cmd	2005-11-13 07:24:44.000000000 +0900
@@ -1,6 +1,7 @@
 @echo off
 
-perl Configure OS2-EMX
+rm -f Makefile crypto/opensslconf.h
+perl Configure OS2-EMX enable-mdc2 enable-rc5
 perl util\mkfiles.pl > MINFO
 
 @rem create make file
@@ -8,7 +9,7 @@
 perl util\mk1mf.pl dll OS2-EMX > OS2-EMX-DLL.mak
 
 echo Generating export definition files
-perl util\mkdef.pl crypto OS2 > os2\crypto.def
+perl util\mkdef.pl crypto OS2 | perl os2\defkludge.pl > os2\crypto.def
 perl util\mkdef.pl ssl OS2 > os2\ssl.def
 
 echo Generating x86 for GNU assember
@@ -71,16 +72,16 @@
 mkdir noname
 :nomkdir
 
-perl backwardify.pl		crypto.def	>backward_crypto.def
+perl backwardify.pl crypto.def | perl fwdkludge.pl	>backward_crypto.def
 perl backwardify.pl		ssl.def		>backward_ssl.def
-perl backwardify.pl -noname	crypto.def	>noname\backward_crypto.def
+perl backwardify.pl -noname	crypto.def | perl fwdkludge.pl >noname\backward_crypto.def
 perl backwardify.pl -noname	ssl.def		>noname\backward_ssl.def
 
 echo Creating backward compatibility forwarder dlls:
 echo  crypto.dll
-gcc -Zomf -Zdll -Zcrtdll -o crypto.dll backward_crypto.def 2>&1 | grep -v L4085
+gcc -Zomf -Zdll -Zmtd -o crypto.dll backward_crypto.def 2>&1 | grep -v L4085
 echo  ssl.dll
-gcc -Zomf -Zdll -Zcrtdll -o ssl.dll backward_ssl.def 2>&1 | grep -v L4085
+gcc -Zomf -Zdll -Zmtd -o ssl.dll backward_ssl.def 2>&1 | grep -v L4085
 
 echo Creating smaller backward compatibility forwarder dlls:
 echo These DLLs are not good for runtime resolution of symbols.
--- openssl-0.9.8a-org/os2/defkludge.pl	1970-01-01 00:00:00.000000000 
+++ openssl-0.9.8a/os2/defkludge.pl	2005-11-13 05:52:04.000000000 +0900
@@ -0,0 +1,10 @@
+#!/usr/bin/perl -w
+
+while(<>) {
+  s/^\s*pqueue_print\s*[=\s].*\n//;
+  s/^\s*ENGINE_load_gmp\s*[=\s].*\n//;
+  print $_;
+}
+
+print "    ERR_load_CRYPTOlib_strings  \@1009\n";
+print "    OCSP_crlID2_new  \@3181\n";
--- openssl-0.9.8a-org/os2/fwdkludge.pl	1970-01-01 00:00:00.000000000 
+++ openssl-0.9.8a/os2/fwdkludge.pl	2005-11-13 07:28:22.000000000 +0900
@@ -0,0 +1,18 @@
+#!/usr/bin/perl -w
+
+while(<>) {
+  s/EVP_aes_128_cfb128/EVP_aes_128_cfb/;
+  s/EVP_aes_192_cfb128/EVP_aes_192_cfb/;
+  s/EVP_aes_256_cfb128/EVP_aes_256_cfb/;
+  s/EVP_bf_cfb64/EVP_bf_cfb/;
+  s/EVP_cast5_cfb64/EVP_cast5_cfb/;
+  s/EVP_des_cfb64/EVP_des_cfb/;
+  s/EVP_des_ede3_cfb64/EVP_des_ede3_cfb/;
+  s/EVP_des_ede_cfb64/EVP_des_ede_cfb/;
+  s/EVP_idea_cfb64/EVP_idea_cfb/;
+  s/EVP_rc2_cfb64/EVP_rc2_cfb/;
+  s/EVP_rc5_32_12_16_cfb64/EVP_rc5_32_12_16_cfb/;
+
+  print $_;
+}
+
--- openssl-0.9.8a-org/os2/no_rte_forwarder.cmd	1970-01-01 00:00:00.000000000 
+++ openssl-0.9.8a/os2/no_rte_forwarder.cmd	2005-11-13 07:34:36.000000000 +0900
@@ -0,0 +1,10 @@
+@echo off
+echo Generate minimal forwarding DLLs.
+echo crypto.dll
+link386 /NOI /NOLOGO \emx\lib\res0.obj,crypto.dll,nul,,backward_crypto.def 2>&1 | grep -v L4085
+echo ssl.dll
+link386 /NOI /NOLOGO \emx\lib\res0.obj,ssl.dll,nul,,backward_ssl.def 2>&1 | grep -v L4085
+echo noname/crypto.dll
+link386 /NOI /NOLOGO \emx\lib\res0.obj,noname\crypto.dll,nul,,noname\backward_crypto.def 2>&1 | grep -v L4085
+echo noname/ssl.dll
+link386 /NOI /NOLOGO \emx\lib\res0.obj,noname\ssl.dll,nul,,noname\backward_ssl.def 2>&1 | grep -v L4085
